part of flutter_aws_rest;

class AwsRequest {
  static final _emptySha256 = sha256.convert(new List<int>());
  static final _emptyMd5 = md5.convert(new List<int>());
  final List<int> bytes;
  final String payloadSha256;
  final String payloadMd5;
  final Map<String, String> headers;

  bool get isEmpty => this.bytes == null;

  AwsRequest(this.bytes, this.payloadSha256, this.payloadMd5, this.headers);

  factory AwsRequest.fromBytes(List<int> bytes,
      {Map<String, String> headers: const {}}) {
    return new AwsRequest(
        bytes, sha256.convert(bytes).toString(), md5.convert(bytes).toString(), headers);
  }

  factory AwsRequest.noPayload({Map<String, String> headers: const {}}) {
    return new AwsRequest(null, _emptySha256.toString(), _emptyMd5.toString(), headers);
  }


}
